(function (sugo) {
               sugo.enable_page_event = $sugo_enable_page_event$;

               if (window.sugo && sugo.enable_page_event) {
                   var tmp_duration = (new Date().getTime() - sugo.enter_time) / 1000;
                   var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                   tmp_props.duration = tmp_duration;
                   sugo.track('停留', tmp_props);
               }
               sugo.auto_track = '$sugo_auto_track$';
               sugo.single_code = '';
               sugo.relative_path = '$sugo_relative_path$';
               sugo.url = '$sugo_url$';
               sugo.all_page_info = $all_page_info$;
               sugo.init = {
                    'code':  '$sugo_init_code$',
                    'page_name':  '$sugo_init_page_name$',
                    'page_category':  '$sugo_init_page_category$'
               };
               sugo.view_props = {};

               sugo.rawTrack = function (event_id, event_name, props) {
                    if (!props) {
                       props = {};
                    }
                    if(sugo.single_code) {
                     props.$sugo_path_name$ = sugo.relative_path +  '##' + sugo.single_code;
                    } else {
                     props.$sugo_path_name$ = sugo.relative_path;
                    }

                    if (!props.$sugo_page_name$ && sugo.init.page_name) {
                       props.$sugo_page_name$ = sugo.init.page_name;
                    }
                    if (!props.$sugo_page_category_key$ && sugo.init.page_category) {
                       props.$sugo_page_category_key$ = sugo.init.page_category;
                    }
                    window.sugoEventListener.track(event_id, event_name, JSON.stringify(props));
               };
               sugo.track = function (event_name, props) {
                   sugo.rawTrack('', event_name, props);
               };
               sugo.timeEvent = function (event_name) {
                   window.sugoEventListener.timeEvent(event_name);
               };

               sugo.registerSuperProperties = function(props) {
                       window.sugoEventListener.registerSuperProperties(JSON.stringify(props));
               };
               sugo.login = function(key, value) {
                   window.sugoEventListener.login(key, value)
               };
               sugo.logout = function(key, value) {
                   window.sugoEventListener.logout()
               };
               var sugoio = {
                   track: sugo.track,
                   time_event: sugo.timeEvent
               };

               if (sugo && sugo.init.code) {
                      var view_props = {};
                      try {
                          var init_code = new Function('sugo', sugo.init.code);
                          view_props = init_code(sugo);
                      } catch (e) {
                          console.log(sugo.init.code);
                          view_props = {};
                      }
                      sugo.view_props = Object.assign({}, sugo.view_props, view_props);
                }
               if (sugo.enable_page_event) {
                   var ele = document.getElementById("eventdataid");
                   if (ele != null){
                       var value = ele.getAttribute("value");
                       if (value != null){
                            sugo.view_props["eventdataid"] = value;
                       }
                   }
                   var title = document.title;
                   if (title != null){
                        sugo.view_props["title"] = title;
                   }
                   var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                   debugger;
                   sugo.track('浏览', tmp_props);

               }




               sugo.enter_time = new Date().getTime();

               if (!window.sugo && sugo.enable_page_event) {
                   window.addEventListener('unload', function (e) {
                       var tmp_duration = (new Date().getTime() - sugo.enter_time) / 1000;
                       var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                       tmp_props.duration = tmp_duration;
                       sugo.track('停留', tmp_props);
                   });
               }

               sugo.current_page = '$sugo_activity_name$::' + sugo.relative_path;
               sugo.h5_event_bindings = $sugo_h5_event_bindings$;
               sugo.sugo_hashcode = $sugo_hashcode$;
               sugo.current_event_bindings = {};
               for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                   var b_event = sugo.h5_event_bindings[i];
                   var pages = new Array();
                   pages = sugo.current_page.split("::");
                   if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                       var b_key = JSON.stringify(b_event.path);
                       sugo.current_event_bindings[b_key] = b_event;
                   }
               }

               sugo.isElementInViewport = function (rect) {
                   return ( rect.top >= 0 && rect.left >= 0 && rect.bottom <= sugo.clientHeight && rect.right <= sugo.clientWidth);
               };

               sugo.excludeControl = ['symbol', 'SCRIPT'];
               sugo.handleNodeChild = function(childrens, nodeJSONArray, parent_path) {
                   for (var i = 0; i < childrens.length; i++) {
                       var nodeChildren = childrens[i];
                       if (sugo.excludeControl.indexOf(nodeChildren.tagName) >= 0) {
                           continue;
                       }
                       var rect = nodeChildren.getBoundingClientRect();
                       var htmlNode = {};
                       var temp_rect = {
                           top: rect.top,
                           left: rect.left,
                           width: rect.width,
                           height: rect.height
                       };
                       htmlNode.rect = temp_rect;
                       var childPath = sugoioKit.cssPath(nodeChildren).replace(/  /g," ");
                       htmlNode.path = childPath;
                       htmlNode.classList = nodeChildren.classList;
                       if(nodeChildren.innerText != undefined && nodeChildren.innerText.length > 29){
                          htmlNode.sugo_autotrack_content = nodeChildren.innerText.substring(0,30);
                       }else{
                          htmlNode.sugo_autotrack_content = nodeChildren.innerText;
                       }
                       nodeJSONArray.push(htmlNode);
                       if (nodeChildren.children) {
                           sugo.handleNodeChild(nodeChildren.children, nodeJSONArray, childPath);
                       }
                   }
               };

               sugo.reportNodes = function () {
                   var startTime = new Date().getTime();
                   var nodeJSONArray = [];
                   var body = document.getElementsByTagName('body')[0];
                   var childrens = body.children;
                   var parent_path = '';
                   sugo.clientWidth = (window.innerWidth || document.documentElement.clientWidth);
                   sugo.clientHeight = (window.innerHeight || document.documentElement.clientHeight);
                   sugo.handleNodeChild(childrens, nodeJSONArray, parent_path);
                   if (window.sugoWebNodeReporter) {
                       window.sugoWebNodeReporter.reportNodes(sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : ''), JSON.stringify(nodeJSONArray), sugo.clientWidth, sugo.clientHeight, document.title);
                   }
                   return 'ok';
               };


               sugo.autoTrackDelegate = function (eventType) {
                              function handle(e) {
                                  var evt = window.event ? window.event : e;
                                  var target = evt.target || evt.srcElement;
                                  var custom_props = {};
                                  var xpath = sugoioKit.cssPath(target).replace(/  /g," ");
                                  var eventName = "";
                                  var isMatch = false;
                                  var paths = Object.keys(sugo.current_event_bindings);
                                  for (var idx = 0; idx < paths.length; idx++) {
                                     var path_str = paths[idx];
                                     var event = sugo.current_event_bindings[path_str];
                                     if (event.event_type != eventType) {
                                         continue;
                                     }
                                     var path = event.path.path.replace(/  /g," ");
                                     var isSimilar = false;
                                     if (event.similar === true) {
                                         path = event.similar_path.replace(/  /g," ");
                                         var strs = new Array();
                                         strs = path.split("(n)");
                                         var length = strs[0].length;
                                         var currentText = xpath.substring(0,length);
                                         if (strs[0] === currentText){
                                            length = strs[1].length;
                                            currentText = xpath.replace(strs[0],'').substring(xpath.replace(strs[0],'').indexOf(')') +1);
                                            if(strs[1].replace(' ','') === currentText.replace(' ','')){
                                                isSimilar = true;
                                            }
                                         }
                                     }

                                     if(path === xpath || isSimilar){
                                         isMatch = true;
                                         for(var key in event.binds){
                                             var value = event.binds[key];
                                             var binds_path = value.path;
                                             var binds_similar = value.similar;
                                             if (isSimilar || path === xpath){
                                             try {
                                                    if (binds_similar && isSimilar && path !== xpath){
                                                         var similarPath = event.similar_path;
                                                         var strs = new Array();
                                                         strs = similarPath.split("(n)");
                                                         var length = strs[0].length;
                                                         var currentText = binds_path.substring(0,length);
                                                         if (strs[0] === currentText){
                                                            length = strs[1].length;
                                                            var num = xpath.replace(strs[0],'').replace(strs[1],'').replace('(','').replace(')','').replace(' ','');
                                                            var tail_path = value.path.replace(strs[0],'');
                                                            var index = tail_path.indexOf(')');
                                                            tail_path = tail_path.substring(index+1);
                                                            binds_path = strs[0]+'('+num + ')' + tail_path;
                                                         }
                                                    }
                                                }
                                                catch(err){}
                                                binds_path = binds_path.replace(' ','');
                                                var bind = undefined;
                                                try {
                                                    bind = document.querySelector(binds_path);
                                                    }
                                                catch(err){
                                                    }
                                                if (bind === undefined){
                                                    continue;
                                                }
                                                var text = bind.innerText;
                                                if (text === ""){
                                                    text = bind.parentNode.innerText;
                                                }
                                                custom_props[key] = text;
                                             }
                                          }


                                         if (event.code && event.code.replace(/(^\\s*)|(\\s*$)/g, '') != '') {
                                             try {
                                                 var sugo_props = new Function('e', 'element', 'conf', 'instance', event.code);
                                                 var map = sugo_props(e, ele, event, sugo);
                                                 for(var key in map){
                                                    custom_props[key] = map[key];
                                                 }
                                             } catch (e) {
                                                 console.log(event.code);
                                             }
                                         }
                                         custom_props.from_binding = true;
                                         custom_props.event_type = eventType;
                                         var data_code = target.getAttribute("data-code");
                                         if (data_code != null){
                                           custom_props.data_code = data_code;
                                         }
                                         custom_props.is_event_track = true;
                                         custom_props.event_label = target.innerText;
                                         custom_props.xpath = xpath.replace(/  /g," ");
                                         custom_props.url = sugo.url;
                                         sugo.rawTrack("", event.event_name, custom_props);

                                     }
                                  }
                                  var currentTarget = e ? e.currentTarget : this;

                                  custom_props.from_binding = true;
                                  custom_props.event_type = eventType;

                                  var innerText = target.innerText;
                                  if (innerText === ""){
                                    innerText = target.parentNode.innerText;
                                  }

                                  var data_code = target.getAttribute("data-code");
                                  if (data_code != null){
                                  custom_props.data_code = data_code;
                                  }
                                  custom_props.event_label = target.innerText;
                                  custom_props.xpath = xpath.replace(/  /g," ");
                                  if (isMatch || sugo.auto_track === '0'){
                                    return;
                                  }
                                  custom_props.is_event_track = true;
                                  custom_props.auto_track = true;
                                  custom_props.url = sugo.url;
                                  if (eventName === ""){
                                  if (innerText !== ""){
                                      eventName = innerText;
                                    }else {
                                    eventName = "全埋点事件";
                                    }
                                  }
                                  sugo.rawTrack("", eventName, custom_props);
                              }
                              document.addEventListener(eventType, handle, true);
               };

               sugo._getAssociatesElement = function (bind= {}, parentSimilarPath) {

                   var getChildSimilarPath = (p_path, c_path) => {
                       c_path = sugoioKit.entire(document.querySelector(c_path));
                       let sameIdx = 0;
                       let pathLength = p_path.length;
                       for (let i = 0; i < pathLength; i++) {
                           if (p_path.charAt(i) !== c_path.charAt(i)) {
                               sameIdx = i;
                               break;
                           }
                       }
                       var similarIdex = p_path.substr(sameIdx).substring(0, p_path.substr(sameIdx).indexOf(')'));
                       var similarEndPath =  c_path.substr(sameIdx).substring(c_path.substr(sameIdx).indexOf(')'));
                       return c_path.substring(0, sameIdx) + similarIdex + similarEndPath;
                   };

                   let path = bind.path;
                   if (bind.similar) {
                       path = getChildSimilarPath(parentSimilarPath, path);
                   }
                   return document.querySelector(path) || {};
               };

               sugo.delegate = function(eventType) {
                   function handle(e) {
                       var evt = window.event ? window.event : e;
                       var target = evt.target || evt.srcElement;
                       var currentTarget = e ? e.currentTarget : this;
                       var paths = Object.keys(sugo.current_event_bindings);
                       var isMatch = false;
                       for (var idx = 0; idx < paths.length; idx++) {
                           var path_str = paths[idx];
                           var event = sugo.current_event_bindings[path_str];
                           if (event.event_type != eventType) {
                               continue;
                           }
                           var path = event.path.path;
                           if (event.similar === true || event.similar === 1) {
                               path = event.similar_path ? event.similar_path : path.replace(/:nth-child\([0-9]*\)/g, '');
                           }
                           if(path && path.indexOf('icbc:') !== -1){
                                path = path.replace(/icbc:(\w+)/g, 'icbc\\:$1');
                           }
                           var eles = document.querySelectorAll(path) || [];

                           for (var eles_idx = 0; eles_idx < eles.length; eles_idx++) {
                               var ele = eles[eles_idx];
                               var parentNode = target;
                               while (parentNode) {
                                   if (parentNode === ele) {
                                       var custom_props = {};
                                       if (event.code && event.code.replace(/(^\s*)|(\s*$)/g, '') != '') {
                                           try {
                                               var sugo_props = new Function('e', 'element', 'conf', 'instance', event.code);
                                               custom_props = sugo_props(e, ele, event, sugo);
                                           } catch (e) {
                                               console.log(event.code);
                                           }
                                       }
                                       custom_props.from_binding = true;
                                       custom_props.event_type = eventType;
                                       custom_props.event_label = ele.innerText;
                                       custom_props.sugo_autotrack_path = path_str;
                                       custom_props.sugo_autotrack_page_path = sugo.view_controller + "::" + sugo.relative_path;
                                       var data_code = target.getAttribute("data-code") || parentNode.getAttribute('data-code');
                                       if (data_code != null){
                                           custom_props.data_code = data_code;
                                       }
                                        if (event.binds) {
                                            var eventEntirePath = sugoioKit.entire(ele);
                                            for (var key in event.binds) {
                                                var bind = event.binds[key];
                                                var bindObj = {};
                                                bindObj = sugo._getAssociatesElement(bind, eventEntirePath);
                                                if (bindObj.tagName && (bindObj.tagName === 'INPUT' || bindObj.tagName === 'SELECT')) {
                                                    custom_props[key] = bindObj.value;
                                                } else if (bindObj.tagName && bindObj.textContent) {
                                                    custom_props[key] = bindObj.textContent;
                                                }
                                            }
                                        }

                                       sugo.rawTrack("", event.event_name, custom_props);
                                       isMatch = true;
                                       break;
                                   }
                                   parentNode = parentNode.parentNode;
                               }
                           }

                       }

                       if (isMatch || sugo.auto_track === '0') {
                             return;
                       }

                       var custom_props ={};
                       var xpath = sugoioKit.cssPath(target).replace(/  /g," ");
                       custom_props.sugo_auto_track = true;
                       custom_props.from_binding = true;
                       custom_props.event_type = eventType;
                       custom_props.event_label = target.innerText;

                       custom_props.sugo_autotrack_path = xpath;
                       custom_props.sugo_autotrack_page_path = sugo.view_controller + "::" + sugo.relative_path;
                       var event_name = '';
                       if (target.innerText === ''){
                           var ele = target.parentNode;
                           event_name = ele.innerText;
                       } else {
                           event_name = target.innerText;
                       }
                       if (event_name.replace(' ', '') === ''){
                           event_name = '全埋点事件';
                       }
                       var data_code = target.getAttribute("data-code");
                       if (data_code != null){
                           custom_props.data_code = data_code;
                       }

                       sugo.rawTrack("", event_name, custom_props);

                   }
                   document.addEventListener(eventType, handle, true);
               };

               sugo.bindEvent = function () {
                   sugo.delegate('click');
                   sugo.delegate('focus');
                   sugo.delegate('change');
                   sugo.delegate('touchstart');
                   sugo.delegate('touchend');
               };

               if (!window.sugo) {
                   sugo.bindEvent();
               }

               sugo.showHeatMap = function () {
                   var isShowHeatMap = window.sugoEventListener.isShowHeatMap();
                   console.log('isShowHeatMap:' + isShowHeatMap);
                   if (!isShowHeatMap) {
                       return;
                   }
                   var pathsOfCurrentEventBindings = Object.keys(sugo.current_event_bindings);
                   for (var idx = 0; idx < pathsOfCurrentEventBindings.length; idx++) {
                       var hm_path_str = pathsOfCurrentEventBindings[idx];
                       var hm_event = sugo.current_event_bindings[hm_path_str];
                       var hm_eventId = hm_event.event_id;
                       var heatColor = window.sugoEventListener.getEventHeatColor(hm_eventId);
                       hm_event.heatColor = heatColor;
                   }

                   var idOfHeatMap = 'sugo_heat_map';
                   var hm_defaultZIndex = 1000;
                   var hmDiv = document.getElementById(idOfHeatMap);
                   if (hmDiv) {
                       document.body.removeChild(document.getElementById(idOfHeatMap));
                   }
                   hmDiv = document.createElement('div');
                   hmDiv.id = idOfHeatMap;
                   hmDiv.style.position = 'absolute';
                   hmDiv.style.pointerEvents = 'none';
                   hmDiv.style.top = '0px';
                   hmDiv.style.left = '0px';
                   document.body.appendChild(hmDiv);
                   for (var i = 0; i < pathsOfCurrentEventBindings.length; i++) {
                       var path_str = pathsOfCurrentEventBindings[i];
                       var event = sugo.current_event_bindings[path_str];
                       var path = event.path.path;
                       if(path && path.indexOf('icbc:') !== -1){
                           path = path.replace(/icbc:(\w+)/g, 'icbc\\:$1');
                       }
                       var eles = document.querySelectorAll(path);
                       if (eles && event.heatColor) {
                           var color = event.heatColor;
                           var r_color = (color >> 4) & 0x000000ff;
                           var g_color = (color >> 2) & 0x000000ff;
                           var b_color = color & 0x000000ff;

                           for (var index = 0; index < eles.length; index++) {
                               var div = document.createElement('div');
                               div.id = event.event_id;
                               div.style.position = 'absolute';
                               div.style.pointerEvents = 'none';
                               div.style.opacity = 0.8;
                               var z = eles[index].style.zIndex;
                               div.style.zIndex = z ? parseInt(z) + 1 : hm_defaultZIndex;
                               var rect = eles[index].getBoundingClientRect();
                               div.style.top = rect.top + 'px';
                               div.style.left = rect.left + 'px';
                               div.style.width = rect.width + 'px';
                               div.style.height = rect.height + 'px';
                               div.style.background = 'radial-gradient(rgb(${r_color}, ${g_color}, ${b_color}), white)';
                               hmDiv.appendChild(div);
                           }
                       }
                   }
               };

               if (sugo.showHeatMap) {
                   sugo.showHeatMap();
               }

           sugo.registerPathName = function(){
                   var props = {};
                   if(sugo.single_code) {
                       props.path_name = sugo.relative_path + "##" + sugo.single_code;
                   } else {
                       props.path_name = sugo.relative_path;
                   }
                   window.sugoEventListener.registerPathName(props.path_name, sugo.sugo_hashcode);
               };

            sugo.registerPathName();

            sugo.load = function(code,cite) {
                   sugo.unLoad();
                   if(cite.options && cite.options.openPolicy === 1) {
                   if(sugo.appendHistory && sugo.appendHistory.length) {
                       sugo.appendHistory.push(code);
                   } else {
                       sugo.appendHistory = [sugo.single_code, code];
                   }
               } else {
                   sugo.appendHistory = null;
               }
                   sugo.single_code = code;
                   sugo.init_path();
                   var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                   sugo.track('浏览', tmp_props);
                   sugo.enter_time = new Date().getTime();

               }
               ;
               sugo.unLoad = function() {
                   if (sugo.single_code && sugo.enter_time) {
                       var duration = (new Date().getTime() - sugo.enter_time) / 1000;
                       var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                       tmp_props.duration = duration;
                       sugo.track('停留', tmp_props);
                       sugo.enter_time = null ;
                       window.sugoWebNodeReporter.isPageFinish(false);
                   }
               };

               sugo.unMount = function(code, cite) {
                   if(cite.options && cite.options.openPolicy === 1) {
                       if(sugo.appendHistory && sugo.appendHistory.length) {
                   var hLenght = sugo.appendHistory.findIndex(function(x) { return x === code});
                   sugo.appendHistory = sugo.appendHistory.slice(0, hLenght > 0 ? hLenght : 0);
                   if (sugo.appendHistory.length > 0) {
                       var single_code = sugo.appendHistory[sugo.appendHistory.length - 1];
                       sugo.load(single_code, {});
                   }
                   }
                 }
               };
            sugo.init_path = function () {
                      sugo.current_page = '$sugo_activity_name$::' + sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : '');
                      sugo.current_event_bindings = {};
                      for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                       var b_event = sugo.h5_event_bindings[i];
                       if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                           var b_key = JSON.stringify(b_event.path);
                           sugo.current_event_bindings[b_key] = b_event;
                       }
                     }

                    var page_obj = sugo.all_page_info[sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : '')];
                    if(page_obj){
                    sugo.init = {
                        'code':page_obj.code,
                        'page_name': page_obj.page_name,
                        'page_category': page_obj.page_category
                    };
                   }else{
                       sugo.init = {
                            'code': '',
                            'page_name': '',
                            'page_category': ''
                       };
                   }

               };
               window.sugo = sugo;

            })(window.sugo || {});;

